/**
 * Created by zhanglei on 2017/11/11.
 */
import React, { Component } from 'react';
import { message,Icon } from 'antd';
import PropTypes from 'prop-types';
export default class ToolBar extends Component {
    static propTypes = {
        myDisabled: PropTypes.boolean,
    };
    constructor(props) {
        super(props);
        this.state = {
            isBackground:false,
            isColor:false,
            editStatus:[
                {label:'加粗',value:'bold',icon:'zitijiacu'},
                {label:'斜体',value:'italic',icon:'zitixieti'},
                {label:'下划线',value:'underline',icon:'xiahuaxian'},
                {label:'链接',value:'createLink',icon:'lianjie'}
            ],
            colorData:[
                'red','orange','yellow','#01FF01','#98F5FF','#8686FF','rgb(216, 154, 255)', '#fff',
                '#DE1607','#E49402','#E2E205','#04DE04','rgb(71, 237, 255)','#6363F9','rgb(204, 123, 255)', 'rgb(206, 205, 205)',
                '#C10303','#D08702','#C5C503','#07C307','rgb(0, 221, 245)','#4C4CFB','rgb(184, 70, 255)', 'rgb(183, 183, 183)',
                '#960505','#AB7005','#ABAB03','#02A902','rgb(6, 171, 189)','#3333FF','rgb(167, 25, 255)', 'rgb(148, 148, 148)',
                '#710303','#989805','#989805','#059C05','rgb(9, 138, 152)','blue','#A020F0', 'rgb(76, 75, 75)',
                '#5D0404',' #757504','#757504','green','rgb(2, 99, 109)','blue','#A020F0', '#000','rgb(56, 2, 2)'
            ],
            fontSizeData:[
                {title:'大号',value:'h1',icon:'H1'},
                {title:'中号',value:'h2',icon:'h2'},
                {title:'正常',value:'h3',icon:'h3-copy-copy'},
                {title:'小号',value:'h4',icon:'h4'}
            ],
        };
    }
    //是否可见
    mapEditStatus=(item,classNames)=>{
        return item.map(e=>{
            return <button
                className={ classNames }
                key={e.value}
                title={e.label}
                onClick={(v)=>this.handleClick(v,e.value)}
            >
                <Icon type={e.icon}/>
            </button>
        });
    };
    handleClick=(v,item)=>{
        v.preventDefault();
        if(item === 'createLink'){
            const href = prompt("链接地址", "http://");
            if(href !=='http://'){
                document.execCommand('createLink',false, href);
            }else{
                return false;
            }
        }else{
            document.execCommand(item,false,null);
        }
    };
    textColor=(e)=>{
        e.preventDefault();
        this.setState({isColor:true});
    };
    textBackground=(e)=>{
        e.preventDefault();
        this.setState({isBackground:true});
    };
    mapButtonToFont=(value,classNames)=>{
        return value.map(item=>{
            return <button
                className={ classNames }
                title={ item.title }
                key={ item.icon }
                onClick={(e)=>this.clickFontSize(e,item.value)}>
                <Icon style={{ fontSize:18, marginTop:2 }} type={ item.icon }/>
            </button>
        });
    };
    clickFontSize=(e,name)=>{
        e.preventDefault();
        document.execCommand('formatBlock', false, name);
    };
    insetHtml=(e)=>{
        e.preventDefault();
        const { textHtml } = this.props;
        textHtml&&textHtml(e);
    };
    onchangefile=(e)=>{
        e.preventDefault();
        const { bind_parse } = this.props;
        const arr = e.target.files[0].name.split('.');
        const mode = arr[arr.length - 1];
        if(mode !== 'jpg'&&mode !== 'png'&&mode !== 'jpeg'){
            message.error('仅支持PNG或者JPG的图片格式上传');
            return;
        }
        bind_parse(e.target.files[0]);
    };
    backgroundClick=(e,item)=>{
        e.preventDefault();
        document.execCommand("backColor",false,item);
        this.setState({ isBackground:false });
    };
    colorClick=(e,item)=>{
        e.preventDefault();
        document.execCommand("forecolor",false,item);
        this.setState({ isColor:false });
    };
    render() {
        const {
            editStatus,
            isColor,
            isBackground,
            colorData,
            fontSizeData,
        } = this.state;
        const { myDisabled } = this.props;
        console.log(myDisabled);
        const classNames = myDisabled?'pointerEvent':'pointerEvent1';
        const mapColor = (value)=>{
            return value.map((item,index)=>{
                return <li key={index}>
                    <button
                        className={ classNames }
                        onClick={(e)=>this.colorClick(e,item)}
                        style={{background:item}}>
                    </button>
                </li>
            })
        };
        const mapBackground = (value)=>{
            return value.map((item,index)=>{
                return <li key={index}>
                    <button
                        className={ classNames }
                        onClick={(e)=>this.backgroundClick(e,item)}
                        style={{background:item}}>
                    </button>
                </li>
            })
        };
        return (
            <div id="editor-toolbar" className="clearfix">
                { !!editStatus&&this.mapEditStatus(editStatus,classNames) }
                <div className="color-content">
                    <button
                        className={ classNames }
                        title="字体颜色"
                        onClick={this.textColor}
                    >
                        <Icon type="zitiyanse"/>
                    </button>
                    {
                        isColor&&!isBackground&&
                        <div className="color-main">
                            <ul className="clearfix">
                                { !!colorData&&mapColor(colorData) }
                            </ul>
                        </div>
                    }
                </div>
                <div className="color-content">
                    <button
                        className={ classNames }
                        title="背景颜色"
                        onClick={this.textBackground}
                    >
                        <Icon type="beijingyanse"/>
                    </button>
                    {
                        isBackground&&!isColor&&
                        <div className="color-main">
                            <ul className="clearfix">
                                {!!colorData&&mapBackground(colorData)}
                            </ul>
                        </div>
                    }
                </div>
                { !!fontSizeData&&this.mapButtonToFont(fontSizeData,classNames) }
                <button title="HTML" onClick={this.insetHtml}><Icon type="switcher"/></button>
                <label className={ classNames } htmlFor="male">
                    <span className={ classNames }><Icon type="tupianwenben"/></span>
                </label>
                <input
                    name="male"
                    id="male"
                    type="file"
                    onChange={this.onchangefile}/>
            </div>
        );
    }
}